SystemOrganization addCategory: #'Minecraft-API'!

Object subclass: #Minecraft
	instanceVariableNames: 'socket world'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Minecraft-API'!

!Minecraft methodsFor: 'as yet unclassified' stamp: 'Laura 9/25/2014 10:17'!
generateExampleAssistant
	^ MinecraftExamples newInGame: self.! !

!Minecraft methodsFor: 'as yet unclassified' stamp: 'Laura 9/3/2014 21:04'!
initialize
	super initialize.
	socket := Socket newTCP listenOn: 7000. 
	world := MinecraftWorld newInGame: self.! !

!Minecraft methodsFor: 'accessing' stamp: 'Laura 8/28/2014 19:57'!
socket

	^ socket! !

!Minecraft methodsFor: 'accessing' stamp: 'Laura 8/28/2014 19:57'!
world

	^ world! !

!Minecraft methodsFor: 'accessing' stamp: 'Laura 8/28/2014 19:57'!
world: anObject

	world := anObject! !

Object subclass: #MinecraftCommand
	instanceVariableNames: 'name parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Minecraft-API'!

!MinecraftCommand class methodsFor: 'as yet unclassified' stamp: 'Laura 9/4/2014 15:58'!
newNamed: aString
	^ self new initializeWithName: aString! !

!MinecraftCommand class methodsFor: 'as yet unclassified' stamp: 'Laura 9/4/2014 15:58'!
newNamed: aString withParameters: aDictionary
	^ self new initializeWithName: aString andParameters: aDictionary! !

!MinecraftCommand methodsFor: 'as yet unclassified' stamp: 'Laura 9/4/2014 15:32'!
initializeWithName: aString
	self initialize.
	self name: aString. ! !

!MinecraftCommand methodsFor: 'as yet unclassified' stamp: 'Laura 9/4/2014 15:32'!
initializeWithName: aString andParameters: aDictionary
	self initialize.
	self name: aString. 
	self parameters: aDictionary! !

!MinecraftCommand methodsFor: 'as yet unclassified' stamp: 'Laura 9/4/2014 18:56'!
json
	"More disgustingly written code"
	| parametersString finalString |
	parametersString := ''.
	self parameters keysAndValuesDo: [ :k :v | parametersString := parametersString, k, '>', v, '<' ].
	parametersString := parametersString allButLast.
	finalString := '{"name":"', (self name), '","parametersString":"', parametersString, '"}'.
	^ finalString! !

!MinecraftCommand methodsFor: 'accessing' stamp: 'Laura 9/4/2014 14:57'!
name

	^ name! !

!MinecraftCommand methodsFor: 'accessing' stamp: 'Laura 9/4/2014 14:50'!
name: anObject

	name := anObject! !

!MinecraftCommand methodsFor: 'accessing' stamp: 'Laura 9/4/2014 15:16'!
parameters

	^ parameters! !

!MinecraftCommand methodsFor: 'accessing' stamp: 'Laura 9/4/2014 15:16'!
parameters: anObject

	parameters := anObject! !

Object subclass: #MinecraftExamples
	instanceVariableNames: 'minecraft'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Minecraft-API'!

!MinecraftExamples class methodsFor: 'as yet unclassified' stamp: 'Laura 9/25/2014 10:21'!
newInGame: aMinecraft
	^ self new initializeWithGame: aMinecraft.! !

!MinecraftExamples methodsFor: 'examples' stamp: 'Laura 9/25/2014 10:59'!
dragonCurveOfSize: anInteger atStartingPoint: aPoint iterations: anotherInteger 
	| size startingPoint iterations turns currentDirection lastPoint |
	size := anInteger.
	startingPoint := aPoint.
	iterations := anotherInteger.
	turns := 'l'.
	currentDirection := 0.
	lastPoint := startingPoint.
	(1 to: iterations)
		do: [:m | 
			| turnsToAppend switch |
			turnsToAppend := '', turns.
			switch := turnsToAppend middle.
			switch = $l
				ifTrue: [turnsToAppend
						at: (turnsToAppend size // 2 + 1)
						put: $r]
				ifFalse: [turnsToAppend
						at: (turnsToAppend size // 2 + 1)
						put: $l].
			turns := turns , 'l' , turnsToAppend].
	[(1 to: turns size)
		do: [:m | 
			| newPoint |
			(turns at: m)
					= $l
				ifTrue: [currentDirection := (currentDirection + 1) \\ 4]
				ifFalse: [currentDirection := (currentDirection - 1) \\ 4].
			currentDirection = 0
				ifTrue: [(1 to: size)
						do: [:n | 
							newPoint := Point x: lastPoint x + 1 y: lastPoint y.
							self minecraft world
								atx: newPoint x
								y: 4
								z: newPoint y
								put: (MinecraftBlock newOfKind: 4 at: self minecraft world).
							lastPoint := newPoint]]
				ifFalse: [currentDirection = 1
						ifTrue: [(1 to: size)
								do: [:n | 
									newPoint := Point x: lastPoint x y: lastPoint y + 1.
									self minecraft world
										atx: newPoint x
										y: 4
										z: newPoint y
										put: (MinecraftBlock newOfKind: 4 at: self minecraft world).
									lastPoint := newPoint]]
						ifFalse: [currentDirection = 2
								ifTrue: [(1 to: size)
										do: [:n | 
											newPoint := Point x: lastPoint x - 1 y: lastPoint y.
											self minecraft world
												atx: newPoint x
												y: 4
												z: newPoint y
												put: (MinecraftBlock newOfKind: 4 at: self minecraft world).
											lastPoint := newPoint]]
								ifFalse: [(1 to: size)
										do: [:n | 
											newPoint := Point x: lastPoint x y: lastPoint y - 1.
											self minecraft world
												atx: newPoint x
												y: 4
												z: newPoint y
												put: (MinecraftBlock newOfKind: 4 at: self minecraft world).
											lastPoint := newPoint]]]]]] forkNamed: 'Minecraft Dragon Curve generator fork'.! !

!MinecraftExamples methodsFor: 'examples' stamp: 'Laura 9/30/2014 00:11'!
fasterMandelbrotSetOfSize: anInteger atStartingPoint: aPoint height: anotherInteger
| k points lessIterationsPoints moreIterationsPoints |

k := (4 / anInteger) asFloat.

points := OrderedCollection new.

[(1 to: anInteger) do: [ :m |
	(1 to: anInteger) do: [ :n |
		points add: (MinecraftExamplesMandelbrotPoint x: aPoint x + n -1 y: aPoint y + m - 1 mx: -2 + ((n-1)*k) my: 2 - ((m-1)*k)).
	]
].

points := points select: [ :point | (point passes > 2) and: ((point x even) and: (point y even)) ].

lessIterationsPoints := points select: [ :point | point passes < 15].

moreIterationsPoints := points select: [ :point | point passes >= 15].

lessIterationsPoints do: [ :point |
	(1 to: point passes) do: [ :c |
	self minecraft world atx: point x y: anotherInteger - 1 + c z: point y put: 
		(MinecraftBlock newOfKind: (#(42 41 133 22 57) at: ((point passes \\ 5))+1)  at: self minecraft world).
	]
].

moreIterationsPoints do: [ :point |
	(1 to: 15) do: [ :c |
	self minecraft world atx: point x y: anotherInteger - 1 + c z: point y put: 
		(MinecraftBlock newOfKind: 49 at: self minecraft world).
	]
]] forkNamed: 'Minecraft Mandelbrot set generator thread.'! !

!MinecraftExamples methodsFor: 'initialize-release' stamp: 'Laura 9/25/2014 10:01'!
initializeWithGame: aMinecraft
	minecraft := aMinecraft.! !

!MinecraftExamples methodsFor: 'examples' stamp: 'Laura 9/30/2014 00:17'!
mandelbrotSetOfSize: anInteger atStartingPoint: aPoint height: anotherInteger
| k points lessIterationsPoints moreIterationsPoints |

k := (4 / anInteger) asFloat.

points := OrderedCollection new.

[(1 to: anInteger) do: [ :m |
	(1 to: anInteger) do: [ :n |
		points add: (MinecraftExamplesMandelbrotPoint x: aPoint x + n -1 y: aPoint y + m - 1 mx: -2 + ((n-1)*k) my: 2 - ((m-1)*k)).
	]
].

points := points select: [ :point | (point passes > 1)].

lessIterationsPoints := points select: [ :point | point passes < 15].

moreIterationsPoints := points select: [ :point | point passes >= 15].

lessIterationsPoints do: [ :point |
	(1 to: point passes) do: [ :c |
	self minecraft world atx: point x y: anotherInteger - 1 + c z: point y put: 
		(MinecraftBlock newOfKind: (#(42 41 133 22 57) at: ((point passes \\ 5))+1)  at: self minecraft world).
	]
].

moreIterationsPoints do: [ :point |
	(1 to: 15) do: [ :c |
	self minecraft world atx: point x y: anotherInteger - 1 + c z: point y put: 
		(MinecraftBlock newOfKind: 49 at: self minecraft world).
	]
]] forkNamed: 'Minecraft Mandelbrot set generator thread.'! !

!MinecraftExamples methodsFor: 'accessing' stamp: 'Laura 9/25/2014 10:01'!
minecraft

	^ minecraft! !

!MinecraftExamples methodsFor: 'accessing' stamp: 'Laura 9/25/2014 10:01'!
minecraft: anObject

	minecraft := anObject! !

!MinecraftExamples methodsFor: 'examples' stamp: 'Laura 9/25/2014 10:20'!
sierpinskiTriangleOfSize: anInteger atStartingPoint: aPoint 
	| size vertex1 vertex2 vertex3 vertexes currentPoint |
	size := anInteger.
	vertex1 := aPoint.
	vertex2 := Point x: vertex1 x + size y: vertex1 y.
	vertex3 := Point x: vertex1 x + (size / 2) asInteger y: vertex1 y + (size * size - (size / 2 * (size / 2)) nthRoot: 2) asInteger.
	vertexes := OrderedCollection new.
	vertexes add: vertex1;
		 add: vertex2;
		 add: vertex3.
	vertexes
		do: [:m | self minecraft world
				atx: m x
				y: 4
				z: m y
				put: (MinecraftBlock newOfKind: 4 at: self world)].
	currentPoint := Point x: (vertex1 x to: vertex3 x) atRandom y: (vertex1 y to: vertex3 y) atRandom.
	^ ([[| randomVertex newPoint |
	randomVertex := vertexes atRandom.
	newPoint := Point x: randomVertex x + (currentPoint x - randomVertex x / 2) y: randomVertex y + (currentPoint y - randomVertex y / 2).
	(1 to: (1 to: 3) atRandom)
		do: [:n | self minecraft world
				atx: newPoint x asInteger
				y: 3 + n
				z: newPoint y asInteger
				put: (MinecraftBlock newOfKind: 4 at: self world)].
	currentPoint := newPoint] repeat]
		forkNamed: 'Minecraft Sierpinski Triangle generator fork').! !

Object subclass: #MinecraftObject
	instanceVariableNames: 'world x y z'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Minecraft-API'!

MinecraftObject subclass: #MinecraftBlock
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Minecraft-API'!

!MinecraftBlock class methodsFor: 'as yet unclassified' stamp: 'Laura 9/4/2014 14:41'!
newAt: aMinecraftWorld 
	^ self basicNew initializeWithDefaultIDAt: aMinecraftWorld! !

!MinecraftBlock class methodsFor: 'as yet unclassified' stamp: 'Laura 8/28/2014 19:51'!
newAt: aMinecraftWorld x: anInteger y: anotherInteger z: yetAnotherInteger
	^ self basicNew initializeWithDefaultIDAt: aMinecraftWorld x: anInteger y: anotherInteger z: yetAnotherInteger! !

!MinecraftBlock class methodsFor: 'as yet unclassified' stamp: 'Laura 9/3/2014 21:32'!
newOfKind: anInteger at: aMinecraftWorld
	^ self basicNew initializeWithID: anInteger at: aMinecraftWorld! !

!MinecraftBlock class methodsFor: 'as yet unclassified' stamp: 'Laura 8/28/2014 19:50'!
newOfKind: anInteger at: aMinecraftWorld x: anotherInteger y: yetAnotherInteger z: soManyIntegers
	^ self basicNew initializeWithID: anInteger at: aMinecraftWorld x: anotherInteger y: yetAnotherInteger z: soManyIntegers! !

!MinecraftBlock methodsFor: 'accessing' stamp: 'Laura 8/28/2014 19:55'!
id

	^ id! !

!MinecraftBlock methodsFor: 'accessing' stamp: 'Laura 8/28/2014 19:55'!
id: anObject

	id := anObject! !

!MinecraftBlock methodsFor: 'as yet unclassified' stamp: 'Laura 9/3/2014 21:32'!
initializeWithDefaultIDAt: aMinecraftWorld
	self initializeWithID: 1 at: aMinecraftWorld! !

!MinecraftBlock methodsFor: 'as yet unclassified' stamp: 'Laura 8/28/2014 19:54'!
initializeWithDefaultIDAt: aMinecraftWorld x: anInteger y: anotherInteger z: yetAnotherInteger
	self initializeWithID: 1 at: aMinecraftWorld x: anInteger y: anotherInteger z: yetAnotherInteger! !

!MinecraftBlock methodsFor: 'as yet unclassified' stamp: 'Laura 9/3/2014 21:33'!
initializeWithID: anInteger at: aMinecraftWorld
	self initializeWithWorld: aMinecraftWorld.
	self id: anInteger.! !

!MinecraftBlock methodsFor: 'as yet unclassified' stamp: 'Laura 8/28/2014 19:53'!
initializeWithID: anInteger at: aMinecraftWorld x: anotherInteger y: yetAnotherInteger z: soManyIntegers
	self initializeWithWorld: aMinecraftWorld x: anotherInteger y: yetAnotherInteger z: soManyIntegers.
	self id: anInteger.! !

MinecraftObject subclass: #MinecraftEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Minecraft-API'!

!MinecraftObject class methodsFor: 'instance creation' stamp: 'Laura 9/3/2014 21:32'!
newAt: aMinecraftWorld
	^ self basicNew initializeWithWorld: aMinecraftWorld! !

!MinecraftObject class methodsFor: 'instance creation' stamp: 'Laura 8/21/2014 18:23'!
newAt: aMinecraftWorld x: aNumber y: anotherNumber z: yetAnotherNumber
	^ self basicNew initializeWithWorld: aMinecraftWorld x: aNumber y: anotherNumber z: yetAnotherNumber! !

!MinecraftObject methodsFor: 'as yet unclassified' stamp: 'Laura 9/3/2014 21:32'!
initializeWithWorld: aMinecraftWorld
	self initialize.
	self world: aMinecraftWorld! !

!MinecraftObject methodsFor: 'as yet unclassified' stamp: 'Laura 8/21/2014 18:24'!
initializeWithWorld: aMinecraftWorld x: aNumber y: anotherNumber z: yetAnotherNumber
	self initialize.
	self world: aMinecraftWorld; x: aNumber; y: anotherNumber; z: yetAnotherNumber.! !

!MinecraftObject methodsFor: 'accessing' stamp: 'Laura 8/21/2014 18:24'!
world

	^ world! !

!MinecraftObject methodsFor: 'accessing' stamp: 'Laura 8/21/2014 18:24'!
world: anObject

	world := anObject! !

!MinecraftObject methodsFor: 'accessing' stamp: 'Laura 8/21/2014 18:24'!
x

	^ x! !

!MinecraftObject methodsFor: 'accessing' stamp: 'Laura 8/21/2014 18:24'!
x: anObject

	x := anObject! !

!MinecraftObject methodsFor: 'accessing' stamp: 'Laura 8/21/2014 18:24'!
y

	^ y! !

!MinecraftObject methodsFor: 'accessing' stamp: 'Laura 8/21/2014 18:24'!
y: anObject

	y := anObject! !

!MinecraftObject methodsFor: 'accessing' stamp: 'Laura 8/21/2014 18:24'!
z

	^ z! !

!MinecraftObject methodsFor: 'accessing' stamp: 'Laura 8/21/2014 18:24'!
z: anObject

	z := anObject! !

Object subclass: #MinecraftWorld
	instanceVariableNames: 'minecraft'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Minecraft-API'!

!MinecraftWorld class methodsFor: 'as yet unclassified' stamp: 'Laura 8/21/2014 18:27'!
newInGame: aMinecraft
	^ self new initializeWithGame: aMinecraft! !

!MinecraftWorld methodsFor: 'as yet unclassified' stamp: 'Laura 9/11/2014 17:27'!
atx: aNumber y: anotherNumber z: yetAnotherNumber 
	| parameters command |
	parameters := Dictionary new.
	parameters at: 'x' put: aNumber asString;
		 at: 'y' put: anotherNumber asString;
		 at: 'z' put: yetAnotherNumber asString.
	command := MinecraftCommand newNamed: 'getBlock' withParameters: parameters.
	self minecraft socket sendData: command json , Character cr asString.
	"//Tendría que encontrar una manera no tan chota de esperar el
	evento//"
	[self minecraft socket dataAvailable]
		whileFalse: [Transcript show: 'Try again!!';
				 cr].
	^ self minecraft socket receiveData! !

!MinecraftWorld methodsFor: 'as yet unclassified' stamp: 'Laura 9/11/2014 17:13'!
atx: aNumber y: anotherNumber z: yetAnotherNumber put: aMinecraftBlock
	| parameters command |
	parameters := Dictionary new.
	parameters at: 'x' put: aNumber asString; at: 'y' put: anotherNumber asString; at: 'z' put: yetAnotherNumber asString; at: 'blockId' put: aMinecraftBlock id asString. 
	command := MinecraftCommand newNamed: 'putBlock' withParameters: parameters.
	self minecraft socket sendData: (command json, (Character cr asString)). 
	
! !

!MinecraftWorld methodsFor: 'as yet unclassified' stamp: 'Laura 8/21/2014 18:27'!
initializeWithGame: aMinecraft
	self initialize.
	minecraft := aMinecraft. ! !

!MinecraftWorld methodsFor: 'accessing' stamp: 'Laura 9/4/2014 15:29'!
minecraft

	^ minecraft! !

Point subclass: #MinecraftExamplesMandelbrotPoint
	instanceVariableNames: 'mx my passes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Minecraft-API'!

!MinecraftExamplesMandelbrotPoint class methodsFor: 'as yet unclassified' stamp: 'Laura 9/29/2014 22:17'!
x: anInteger y: anotherInteger mx: aNumber my: anotherNumber
	^ (self x: anInteger y: anotherInteger) initializeWithmx: aNumber my: anotherNumber! !

!MinecraftExamplesMandelbrotPoint methodsFor: 'as yet unclassified' stamp: 'Laura 9/29/2014 23:12'!
initializePasses
	| z iterations origin |
	z := Point x: 0 y: 0.
	iterations := 0.
	origin := Point x: 0 y: 0.
	[ (z dist: origin) < 2 and: (iterations < 50)] whileTrue: [
		z setX: ((z x * z x) - (z y * z y) + self mx) setY: (2 * z x * z y + self my).
		iterations := iterations + 1
	].
	passes := iterations.! !

!MinecraftExamplesMandelbrotPoint methodsFor: 'as yet unclassified' stamp: 'Laura 9/29/2014 22:17'!
initializeWithmx: aNumber my: anotherNumber
	mx := aNumber.
	my := anotherNumber.
	self initializePasses.! !

!MinecraftExamplesMandelbrotPoint methodsFor: 'accessing' stamp: 'Laura 9/29/2014 21:44'!
mx

	^ mx! !

!MinecraftExamplesMandelbrotPoint methodsFor: 'accessing' stamp: 'Laura 9/29/2014 22:16'!
mx: anObject

	mx := anObject.
	self initializePasses.! !

!MinecraftExamplesMandelbrotPoint methodsFor: 'accessing' stamp: 'Laura 9/29/2014 21:44'!
my

	^ my! !

!MinecraftExamplesMandelbrotPoint methodsFor: 'accessing' stamp: 'Laura 9/29/2014 22:16'!
my: anObject

	my := anObject.
	self initializePasses.! !

!MinecraftExamplesMandelbrotPoint methodsFor: 'accessing' stamp: 'Laura 9/29/2014 21:44'!
passes

	^ passes! !
